---
product: "AG Grid"
title: "Column Pinning"
description: "You can pin columns by setting the pinned attribute on the column definition to either 'left' or 'right' ."
framework: react
version: "36.2.0"
related:
    - title: "Configuration"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/configuration/"
    - title: "Column Headers"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-headers/"
    - title: "Column Groups"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-groups/"
    - title: "Column Sizing"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-sizing/"
    - title: "Column Moving"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-moving/"
    - title: "Column Spanning"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-spanning/"
    - title: "Calculated Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/calculated-columns/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Column Pinning

You can pin columns by setting the `pinned` attribute on the column definition to either `'left'` or `'right'`.

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: 'athlete', pinned: 'left' }
]);

<AgGridReact columnDefs={columnDefs} />
```

Below shows an example with three pinned columns on the left and one pinned column on the right. The example also demonstrates changing the pinning via the API at runtime.

The grid will reorder the columns so that 'left pinned' columns come first and 'right pinned' columns come last. In the example below the state of pinned columns impacts the order of the columns such that when 'Country' is pinned, it jumps to the first position.

Use `initialPinned` instead of `pinned` to only set pinning when the column is first created. When column definitions are subsequently updated, `initialPinned` will not re-apply, allowing user changes to be preserved.

#### Column Pinning

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ColumnApiModule, ClientSideRowModelModule];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      headerName: "#",
      colId: "rowNum",
      valueGetter: "node.id",
      width: 80,
      pinned: "left",
    },
    { field: "athlete", width: 150, pinned: "left" },
    { field: "age", width: 90, pinned: "left" },
    { field: "country", width: 150 },
    { field: "year", width: 90 },
    { field: "date", width: 110 },
    { field: "sport", width: 150 },
    { field: "gold", width: 100 },
    { field: "silver", width: 100 },
    { field: "bronze", width: 100 },
    { field: "total", width: 100, pinned: "right" },
  ]);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const clearPinned = useCallback(() => {
    gridRef.current!.api.applyColumnState({ defaultState: { pinned: null } });
  }, []);

  const resetPinned = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "rowNum", pinned: "left" },
        { colId: "athlete", pinned: "left" },
        { colId: "age", pinned: "left" },
        { colId: "total", pinned: "right" },
      ],
      defaultState: { pinned: null },
    });
  }, []);

  const pinCountry = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [{ colId: "country", pinned: "left" }],
      defaultState: { pinned: null },
    });
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <div style={{ padding: "4px" }}>
              <button onClick={clearPinned}>Clear Pinned</button>
              <button onClick={resetPinned}>
                Left = #, Athlete, Age; Right = Total
              </button>
              <button onClick={pinCountry}>Left = Country</button>
            </div>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Column Pinning](https://www.ag-grid.com/archive/36.2.0/examples/column-pinning/column-pinning/reactFunctionalTs/)

## Pinning via Column Dragging

It is possible to pin a column by moving the column in the following ways:

- When other columns are pinned, drag the column to the existing pinned area.
- When no columns are pinned, drag the column to the edge of the grid and wait for approximately one second. The grid will then assume you want to pin and create a pinned area and place the column into it.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/pinning-by-moving.CF95tIue.mp4)

## Resizing Pinned Sections

When resizing pinned columns, the size of the pinned sections (left and right) will be limited to the size of the `grid - 50px`. This will prevent the centre viewport of the grid from becoming inaccessible. For the same reason, if columns that are too wide become pinned, the grid will automatically unpin columns from the pinned sections to make the centre viewport visible again. To customise the columns being unpinned, provide the grid option `processUnpinnedColumns`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `processUnpinnedColumns` | `ProcessUnpinnedColumns` |  |  |  |

## Lock Pinned

If you do not want the user to be able to pin using the UI, set the property `lockPinned=true`. This will block the UI in the following way:

- Dragging a column to the pinned section will not pin the column.
- For AG Grid Enterprise, the column menu will not have a pin option.

The example below demonstrates columns with pinning locked. The following can be noted:

- The column **Athlete** is pinned via the configuration and has `lockPinned=true`. This means the column will be pinned always, it is not possible to drag the column out of the pinned section.
- The column **Age** is not pinned and has `lockPinned=true`. This means the column cannot be pinned by dragging the column.
- All other columns act as normal. They can be added and removed from the pinned section by dragging.

#### Lock Pinned

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [CellStyleModule, ClientSideRowModelModule];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      headerName: "Athlete (locked as pinned)",
      field: "athlete",
      width: 240,
      pinned: "left",
      lockPinned: true,
      cellClass: "lock-pinned",
    },
    {
      headerName: "Age (locked as not pinnable)",
      field: "age",
      width: 260,
      lockPinned: true,
      cellClass: "lock-pinned",
    },
    { field: "country", width: 150 },
    { field: "year", width: 90 },
    { field: "date", width: 150 },
    { field: "sport", width: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <span className="legend-box lock-pinned"></span> Locked Column
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Lock Pinned](https://www.ag-grid.com/archive/36.2.0/examples/column-pinning/lock-pinned/reactFunctionalTs/)


---
product: "AG Grid"
title: "Column Pinning"
description: "You can pin columns by setting the pinned attribute on the column definition to either 'left' or 'right' ."
framework: vue
version: "36.2.0"
related:
    - title: "Configuration"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/configuration/"
    - title: "Column Headers"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-headers/"
    - title: "Column Groups"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-groups/"
    - title: "Column Sizing"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-sizing/"
    - title: "Column Moving"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-moving/"
    - title: "Column Spanning"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-spanning/"
    - title: "Calculated Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/calculated-columns/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Column Pinning

You can pin columns by setting the `pinned` attribute on the column definition to either `'left'` or `'right'`.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: 'athlete', pinned: 'left' }
];
```

Below shows an example with three pinned columns on the left and one pinned column on the right. The example also demonstrates changing the pinning via the API at runtime.

The grid will reorder the columns so that 'left pinned' columns come first and 'right pinned' columns come last. In the example below the state of pinned columns impacts the order of the columns such that when 'Country' is pinned, it jumps to the first position.

Use `initialPinned` instead of `pinned` to only set pinning when the column is first created. When column definitions are subsequently updated, `initialPinned` will not re-apply, allowing user changes to be preserved.

#### Column Pinning

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ColumnApiModule, ClientSideRowModelModule]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
        <div style="padding: 4px">
          <button v-on:click="clearPinned()">Clear Pinned</button>
          <button v-on:click="resetPinned()">Left = #, Athlete, Age; Right = Total</button>
          <button v-on:click="pinCountry()">Left = Country</button>
        </div>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :rowData="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        headerName: "#",
        colId: "rowNum",
        valueGetter: "node.id",
        width: 80,
        pinned: "left",
      },
      { field: "athlete", width: 150, pinned: "left" },
      { field: "age", width: 90, pinned: "left" },
      { field: "country", width: 150 },
      { field: "year", width: 90 },
      { field: "date", width: 110 },
      { field: "sport", width: 150 },
      { field: "gold", width: 100 },
      { field: "silver", width: 100 },
      { field: "bronze", width: 100 },
      { field: "total", width: 100, pinned: "right" },
    ]);
    const rowData = ref<IOlympicData[]>(null);

    function clearPinned() {
      gridApi.value!.applyColumnState({ defaultState: { pinned: null } });
    }
    function resetPinned() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "rowNum", pinned: "left" },
          { colId: "athlete", pinned: "left" },
          { colId: "age", pinned: "left" },
          { colId: "total", pinned: "right" },
        ],
        defaultState: { pinned: null },
      });
    }
    function pinCountry() {
      gridApi.value!.applyColumnState({
        state: [{ colId: "country", pinned: "left" }],
        defaultState: { pinned: null },
      });
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      onGridReady,
      clearPinned,
      resetPinned,
      pinCountry,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Column Pinning](https://www.ag-grid.com/archive/36.2.0/examples/column-pinning/column-pinning/vue3/)

## Pinning via Column Dragging

It is possible to pin a column by moving the column in the following ways:

- When other columns are pinned, drag the column to the existing pinned area.
- When no columns are pinned, drag the column to the edge of the grid and wait for approximately one second. The grid will then assume you want to pin and create a pinned area and place the column into it.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/pinning-by-moving.CF95tIue.mp4)

## Resizing Pinned Sections

When resizing pinned columns, the size of the pinned sections (left and right) will be limited to the size of the `grid - 50px`. This will prevent the centre viewport of the grid from becoming inaccessible. For the same reason, if columns that are too wide become pinned, the grid will automatically unpin columns from the pinned sections to make the centre viewport visible again. To customise the columns being unpinned, provide the grid option `processUnpinnedColumns`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `processUnpinnedColumns` | `ProcessUnpinnedColumns` |  |  |  |

## Lock Pinned

If you do not want the user to be able to pin using the UI, set the property `lockPinned=true`. This will block the UI in the following way:

- Dragging a column to the pinned section will not pin the column.
- For AG Grid Enterprise, the column menu will not have a pin option.

The example below demonstrates columns with pinning locked. The following can be noted:

- The column **Athlete** is pinned via the configuration and has `lockPinned=true`. This means the column will be pinned always, it is not possible to drag the column out of the pinned section.
- The column **Age** is not pinned and has `lockPinned=true`. This means the column cannot be pinned by dragging the column.
- All other columns act as normal. They can be added and removed from the pinned section by dragging.

#### Lock Pinned

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([CellStyleModule, ClientSideRowModelModule]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header"><span class="legend-box lock-pinned"></span> Locked Column</div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :rowData="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        headerName: "Athlete (locked as pinned)",
        field: "athlete",
        width: 240,
        pinned: "left",
        lockPinned: true,
        cellClass: "lock-pinned",
      },
      {
        headerName: "Age (locked as not pinnable)",
        field: "age",
        width: 260,
        lockPinned: true,
        cellClass: "lock-pinned",
      },
      { field: "country", width: 150 },
      { field: "year", width: 90 },
      { field: "date", width: 150 },
      { field: "sport", width: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Lock Pinned](https://www.ag-grid.com/archive/36.2.0/examples/column-pinning/lock-pinned/vue3/)


---
product: "AG Grid"
title: "Column Pinning"
description: "You can pin columns by setting the pinned attribute on the column definition to either 'left' or 'right' ."
framework: angular
version: "36.2.0"
related:
    - title: "Configuration"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/configuration/"
    - title: "Column Headers"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-headers/"
    - title: "Column Groups"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-groups/"
    - title: "Column Sizing"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-sizing/"
    - title: "Column Moving"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-moving/"
    - title: "Column Spanning"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-spanning/"
    - title: "Calculated Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/calculated-columns/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Column Pinning

You can pin columns by setting the `pinned` attribute on the column definition to either `'left'` or `'right'`.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    { field: 'athlete', pinned: 'left' }
];
```

Below shows an example with three pinned columns on the left and one pinned column on the right. The example also demonstrates changing the pinning via the API at runtime.

The grid will reorder the columns so that 'left pinned' columns come first and 'right pinned' columns come last. In the example below the state of pinned columns impacts the order of the columns such that when 'Country' is pinned, it jumps to the first position.

Use `initialPinned` instead of `pinned` to only set pinning when the column is first created. When column definitions are subsequently updated, `initialPinned` will not re-apply, allowing user changes to be preserved.

#### Column Pinning

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ColumnApiModule, ClientSideRowModelModule]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <div style="padding: 4px">
        <button (click)="clearPinned()">Clear Pinned</button>
        <button (click)="resetPinned()">
          Left = #, Athlete, Age; Right = Total
        </button>
        <button (click)="pinCountry()">Left = Country</button>
      </div>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    {
      headerName: "#",
      colId: "rowNum",
      valueGetter: "node.id",
      width: 80,
      pinned: "left",
    },
    { field: "athlete", width: 150, pinned: "left" },
    { field: "age", width: 90, pinned: "left" },
    { field: "country", width: 150 },
    { field: "year", width: 90 },
    { field: "date", width: 110 },
    { field: "sport", width: 150 },
    { field: "gold", width: 100 },
    { field: "silver", width: 100 },
    { field: "bronze", width: 100 },
    { field: "total", width: 100, pinned: "right" },
  ];
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  clearPinned() {
    this.gridApi.applyColumnState({ defaultState: { pinned: null } });
  }

  resetPinned() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "rowNum", pinned: "left" },
        { colId: "athlete", pinned: "left" },
        { colId: "age", pinned: "left" },
        { colId: "total", pinned: "right" },
      ],
      defaultState: { pinned: null },
    });
  }

  pinCountry() {
    this.gridApi.applyColumnState({
      state: [{ colId: "country", pinned: "left" }],
      defaultState: { pinned: null },
    });
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Column Pinning](https://www.ag-grid.com/archive/36.2.0/examples/column-pinning/column-pinning/angular/)

## Pinning via Column Dragging

It is possible to pin a column by moving the column in the following ways:

- When other columns are pinned, drag the column to the existing pinned area.
- When no columns are pinned, drag the column to the edge of the grid and wait for approximately one second. The grid will then assume you want to pin and create a pinned area and place the column into it.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/pinning-by-moving.CF95tIue.mp4)

## Resizing Pinned Sections

When resizing pinned columns, the size of the pinned sections (left and right) will be limited to the size of the `grid - 50px`. This will prevent the centre viewport of the grid from becoming inaccessible. For the same reason, if columns that are too wide become pinned, the grid will automatically unpin columns from the pinned sections to make the centre viewport visible again. To customise the columns being unpinned, provide the grid option `processUnpinnedColumns`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `processUnpinnedColumns` | `ProcessUnpinnedColumns` |  |  |  |

## Lock Pinned

If you do not want the user to be able to pin using the UI, set the property `lockPinned=true`. This will block the UI in the following way:

- Dragging a column to the pinned section will not pin the column.
- For AG Grid Enterprise, the column menu will not have a pin option.

The example below demonstrates columns with pinning locked. The following can be noted:

- The column **Athlete** is pinned via the configuration and has `lockPinned=true`. This means the column will be pinned always, it is not possible to drag the column out of the pinned section.
- The column **Age** is not pinned and has `lockPinned=true`. This means the column cannot be pinned by dragging the column.
- All other columns act as normal. They can be added and removed from the pinned section by dragging.

#### Lock Pinned

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([CellStyleModule, ClientSideRowModelModule]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <span class="legend-box lock-pinned"></span> Locked Column
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      headerName: "Athlete (locked as pinned)",
      field: "athlete",
      width: 240,
      pinned: "left",
      lockPinned: true,
      cellClass: "lock-pinned",
    },
    {
      headerName: "Age (locked as not pinnable)",
      field: "age",
      width: 260,
      lockPinned: true,
      cellClass: "lock-pinned",
    },
    { field: "country", width: 150 },
    { field: "year", width: 90 },
    { field: "date", width: 150 },
    { field: "sport", width: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Lock Pinned](https://www.ag-grid.com/archive/36.2.0/examples/column-pinning/lock-pinned/angular/)
